/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of BDB.xs. Do not edit this file, edit BDB.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "BDB.xs"
#include "xthread.h"

#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

// perl stupidly defines these as macros, breaking
// lots and lots of code.
#undef open
#undef close
#undef abort
#undef malloc
#undef free
#undef send

#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <limits.h>
#include <fcntl.h>

#ifndef _WIN32
# include <sys/time.h>
# include <unistd.h>
#endif

#include <db.h>

#if DB_VERSION_MAJOR < 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR < 4)
# error you need Berkeley DB 4.4 or newer installed
#endif

/* number of seconds after which idle threads exit */
#define IDLE_TIMEOUT 10

typedef DB_ENV      DB_ENV_ornull;
typedef DB_TXN      DB_TXN_ornull;
typedef DBC         DBC_ornull;
typedef DB          DB_ornull;
typedef DB_SEQUENCE DB_SEQUENCE_ornull;

typedef DB_ENV      DB_ENV_ornuked;
typedef DB_TXN      DB_TXN_ornuked;
typedef DBC         DBC_ornuked;
typedef DB          DB_ornuked;
typedef DB_SEQUENCE DB_SEQUENCE_ornuked;

typedef SV SV8; /* byte-sv, used for argument-checking */
typedef char *bdb_filename;

static SV *prepare_cb;

#if DB_VERSION_MINOR >= 6
# define c_close close 
# define c_count count 
# define c_del   del   
# define c_dup   dup   
# define c_get   get   
# define c_pget  pget  
# define c_put   put   
#endif

static char *
get_bdb_filename (SV *sv)
{
  if (!SvOK (sv))
    return 0;

#if _WIN32
  /* win32 madness + win32 perl absolutely brokenness make for horrible hacks */
  {
    STRLEN len;
    char *src = SvPVbyte (sv, len);
    SV *t1 = sv_newmortal ();
    SV *t2 = sv_newmortal ();

    sv_upgrade (t1, SVt_PV); SvPOK_only (t1); SvGROW (t1, len * 16 + 1);
    sv_upgrade (t2, SVt_PV); SvPOK_only (t2); SvGROW (t2, len * 16 + 1);

    len = MultiByteToWideChar (CP_ACP, 0, src, len, (WCHAR *)SvPVX (t1), SvLEN (t1) / sizeof (WCHAR));
    len = WideCharToMultiByte (CP_UTF8, 0, (WCHAR *)SvPVX (t1), len, SvPVX (t2), SvLEN (t2), 0, 0);
    SvPOK_only (t2);
    SvPVX (t2)[len] = 0;
    SvCUR_set (t2, len);

    return SvPVX (t2);
  }
#else
  return SvPVbyte_nolen (sv);
#endif
}

static void
debug_errcall (const DB_ENV *dbenv, const char *errpfx, const char *msg)
{
  printf ("err[%s]\n", msg);
}

static void
debug_msgcall (const DB_ENV *dbenv, const char *msg)
{
  printf ("msg[%s]\n", msg);
}

static char *
strdup_ornull (const char *s)
{
  return s ? strdup (s) : 0;
}

static void
sv_to_dbt (DBT *dbt, SV *sv)
{
  STRLEN len;
  char *data = SvPVbyte (sv, len);

  dbt->data = malloc (len);
  memcpy (dbt->data, data, len);
  dbt->size = len;
  dbt->flags = DB_DBT_REALLOC;
}
	
static void
dbt_to_sv (SV *sv, DBT *dbt)
{
  if (sv)
    {
      SvREADONLY_off (sv);
      sv_setpvn_mg (sv, dbt->data, dbt->size);
      SvREFCNT_dec (sv);
    }

  free (dbt->data);
}
	
enum {
  REQ_QUIT,
  REQ_ENV_OPEN, REQ_ENV_CLOSE, REQ_ENV_TXN_CHECKPOINT, REQ_ENV_LOCK_DETECT,
  REQ_ENV_MEMP_SYNC, REQ_ENV_MEMP_TRICKLE, REQ_ENV_DBREMOVE, REQ_ENV_DBRENAME,
  REQ_DB_OPEN, REQ_DB_CLOSE, REQ_DB_COMPACT, REQ_DB_SYNC, REQ_DB_UPGRADE,
  REQ_DB_PUT, REQ_DB_EXISTS, REQ_DB_GET, REQ_DB_PGET, REQ_DB_DEL, REQ_DB_KEY_RANGE,
  REQ_TXN_COMMIT, REQ_TXN_ABORT, REQ_TXN_FINISH,
  REQ_C_CLOSE, REQ_C_COUNT, REQ_C_PUT, REQ_C_GET, REQ_C_PGET, REQ_C_DEL,
  REQ_SEQ_OPEN, REQ_SEQ_CLOSE, REQ_SEQ_GET, REQ_SEQ_REMOVE,
};

typedef struct bdb_cb
{
  struct bdb_cb *volatile next;
  SV *callback;
  int type, pri, result;

  DB_ENV *env;
  DB *db;
  DB_TXN *txn;
  DBC *dbc;

  UV uv1;
  int int1, int2;
  U32 uint1, uint2;
  char *buf1, *buf2, *buf3;
  SV *sv1, *sv2, *sv3;

  DBT dbt1, dbt2, dbt3;
  DB_KEY_RANGE key_range;
  DB_SEQUENCE *seq;
  db_seq_t seq_t;
} bdb_cb;

typedef bdb_cb *bdb_req;

enum {
  PRI_MIN     = -4,
  PRI_MAX     =  4,

  DEFAULT_PRI = 0,
  PRI_BIAS    = -PRI_MIN,
  NUM_PRI     = PRI_MAX + PRI_BIAS + 1,
};

#define AIO_TICKS ((1000000 + 1023) >> 10)

static SV *on_next_submit;

static unsigned int max_poll_time = 0;
static unsigned int max_poll_reqs = 0;

/* calculcate time difference in ~1/AIO_TICKS of a second */
static int tvdiff (struct timeval *tv1, struct timeval *tv2)
{
  return  (tv2->tv_sec  - tv1->tv_sec ) * AIO_TICKS
       + ((tv2->tv_usec - tv1->tv_usec) >> 10);
}

static int next_pri = DEFAULT_PRI + PRI_BIAS;

static unsigned int started, idle, wanted;

/* worker threads management */
static mutex_t wrklock = X_MUTEX_INIT;

typedef struct worker {
  /* locked by wrklock */
  struct worker *prev, *next;

  thread_t tid;

  /* locked by reslock, reqlock or wrklock */
  bdb_req req; /* currently processed request */
  void *dbuf;
  DIR *dirp;
} worker;

static worker wrk_first = { &wrk_first, &wrk_first, 0 };

static void worker_clear (worker *wrk)
{
}

static void worker_free (worker *wrk)
{
  wrk->next->prev = wrk->prev;
  wrk->prev->next = wrk->next;

  free (wrk);
}

static volatile unsigned int nreqs, nready, npending;
static volatile unsigned int max_idle = 4;
static volatile unsigned int max_outstanding = 0xffffffff;
static int respipe_osf [2], respipe [2] = { -1, -1 };

static mutex_t reslock = X_MUTEX_INIT;
static mutex_t reqlock = X_MUTEX_INIT;
static cond_t  reqwait = X_COND_INIT;

#if WORDACCESS_UNSAFE

static unsigned int get_nready (void)
{
  unsigned int retval;

  X_LOCK   (reqlock);
  retval = nready;
  X_UNLOCK (reqlock);

  return retval;
}

static unsigned int get_npending (void)
{
  unsigned int retval;

  X_LOCK   (reslock);
  retval = npending;
  X_UNLOCK (reslock);

  return retval;
}

static unsigned int get_nthreads (void)
{
  unsigned int retval;

  X_LOCK   (wrklock);
  retval = started;
  X_UNLOCK (wrklock);

  return retval;
}

#else

# define get_nready()   nready
# define get_npending() npending
# define get_nthreads() started

#endif

/*
 * a somewhat faster data structure might be nice, but
 * with 8 priorities this actually needs <20 insns
 * per shift, the most expensive operation.
 */
typedef struct {
  bdb_req qs[NUM_PRI], qe[NUM_PRI]; /* qstart, qend */
  int size;
} reqq;

static reqq req_queue;
static reqq res_queue;

int reqq_push (reqq *q, bdb_req req)
{
  int pri = req->pri;
  req->next = 0;

  if (q->qe[pri])
    {
      q->qe[pri]->next = req;
      q->qe[pri] = req;
    }
  else
    q->qe[pri] = q->qs[pri] = req;

  return q->size++;
}

bdb_req reqq_shift (reqq *q)
{
  int pri;

  if (!q->size)
    return 0;

  --q->size;

  for (pri = NUM_PRI; pri--; )
    {
      bdb_req req = q->qs[pri];

      if (req)
        {
          if (!(q->qs[pri] = req->next))
            q->qe[pri] = 0;

          return req;
        }
    }

  abort ();
}

static int poll_cb (void);
static void req_free (bdb_req req);
static void req_cancel (bdb_req req);

static int req_invoke (bdb_req req)
{
  dSP;

  if (req->callback)
    {
      ENTER;
      SAVETMPS;
      PUSHMARK (SP);

      switch (req->type)
        {
          case REQ_DB_CLOSE:
            SvREFCNT_dec (req->sv1);
            break;

          case REQ_DB_GET:
          case REQ_DB_PGET:
            dbt_to_sv (req->sv3, &req->dbt3);
            break;

          case REQ_C_GET:
          case REQ_C_PGET:
            dbt_to_sv (req->sv1, &req->dbt1);
            dbt_to_sv (req->sv2, &req->dbt2);
            dbt_to_sv (req->sv3, &req->dbt3);
            break;

          case REQ_DB_PUT:
          case REQ_C_PUT:
            dbt_to_sv (0, &req->dbt1);
            dbt_to_sv (0, &req->dbt2);
            break;

          case REQ_DB_KEY_RANGE:
            {
              AV *av = newAV ();

              av_push (av, newSVnv (req->key_range.less));
              av_push (av, newSVnv (req->key_range.equal));
              av_push (av, newSVnv (req->key_range.greater));

              SvREADONLY_off (req->sv1);
              sv_setsv_mg (req->sv1, newRV_noinc ((SV *)av));
              SvREFCNT_dec (req->sv1);
            }
            break;

          case REQ_SEQ_GET:
            SvREADONLY_off (req->sv1);

            if (sizeof (IV) > 4)
              sv_setiv_mg (req->sv1, (IV)req->seq_t);
            else
              sv_setnv_mg (req->sv1, (NV)req->seq_t);

            SvREFCNT_dec (req->sv1);
            break;
        }

      errno = req->result;

      PUTBACK;
      call_sv (req->callback, G_VOID | G_EVAL);
      SPAGAIN;

      FREETMPS;
      LEAVE;
    }

  return !SvTRUE (ERRSV);
}

static void req_free (bdb_req req)
{
  SvREFCNT_dec (req->callback);

  free (req->buf1);
  free (req->buf2);
  free (req->buf3);

  Safefree (req);
}

#ifdef USE_SOCKETS_AS_HANDLES
# define TO_SOCKET(x) (win32_get_osfhandle (x))
#else
# define TO_SOCKET(x) (x)
#endif

static void
create_respipe (void)
{
#ifdef _WIN32
  int arg; /* argg */
#endif
  int old_readfd = respipe [0];

  if (respipe [1] >= 0)
    respipe_close (TO_SOCKET (respipe [1]));

#ifdef _WIN32
  if (PerlSock_socketpair (AF_UNIX, SOCK_STREAM, 0, respipe))
#else
  if (pipe (respipe))
#endif
    croak ("unable to initialize result pipe");

  if (old_readfd >= 0)
    {
      if (dup2 (TO_SOCKET (respipe [0]), TO_SOCKET (old_readfd)) < 0)
        croak ("unable to initialize result pipe(2)");
     
      respipe_close (respipe [0]);
      respipe [0] = old_readfd;
    }

#ifdef _WIN32
  arg = 1;
  if (ioctlsocket (TO_SOCKET (respipe [0]), FIONBIO, &arg)
      || ioctlsocket (TO_SOCKET (respipe [1]), FIONBIO, &arg))
#else
  if (fcntl (respipe [0], F_SETFL, O_NONBLOCK)
      || fcntl (respipe [1], F_SETFL, O_NONBLOCK))
#endif
    croak ("unable to initialize result pipe(3)");

  respipe_osf [0] = TO_SOCKET (respipe [0]);
  respipe_osf [1] = TO_SOCKET (respipe [1]);
}

X_THREAD_PROC (bdb_proc);

static void start_thread (void)
{
  worker *wrk = calloc (1, sizeof (worker));

  if (!wrk)
    croak ("unable to allocate worker thread data");

  X_LOCK (wrklock);
  if (thread_create (&wrk->tid, bdb_proc, (void *)wrk))
    {
      wrk->prev = &wrk_first;
      wrk->next = wrk_first.next;
      wrk_first.next->prev = wrk;
      wrk_first.next = wrk;
      ++started;
    }
  else
    free (wrk);

  X_UNLOCK (wrklock);
}

static void maybe_start_thread (void)
{
  if (get_nthreads () >= wanted)
    return;
  
  /* todo: maybe use idle here, but might be less exact */
  if (0 <= (int)get_nthreads () + (int)get_npending () - (int)nreqs)
    return;

  start_thread ();
}

static void req_send (bdb_req req)
{
  SV *wait_callback = 0;

  if (on_next_submit)
    {
      dSP;
      SV *cb = sv_2mortal (on_next_submit);

      on_next_submit = 0;

      PUSHMARK (SP);
      PUTBACK;
      call_sv (cb, G_DISCARD | G_EVAL);
    }

  // synthesize callback if none given
  if (!req->callback)
    {
      int count;

      dSP;
      PUSHMARK (SP);
      PUTBACK;
      count = call_sv (prepare_cb, G_ARRAY);
      SPAGAIN;

      if (count != 2)
        croak ("prepare callback must return exactly two values\n");

      wait_callback = POPs;
      SvREFCNT_dec (req->callback);
      req->callback = SvREFCNT_inc (POPs);
    }

  ++nreqs;

  X_LOCK (reqlock);
  ++nready;
  reqq_push (&req_queue, req);
  X_COND_SIGNAL (reqwait);
  X_UNLOCK (reqlock);

  maybe_start_thread ();

  if (wait_callback)
    {
      dSP;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (wait_callback, G_DISCARD);
    }
}

static void end_thread (void)
{
  bdb_req req;

  Newz (0, req, 1, bdb_cb);

  req->type = REQ_QUIT;
  req->pri  = PRI_MAX + PRI_BIAS;

  X_LOCK (reqlock);
  reqq_push (&req_queue, req);
  X_COND_SIGNAL (reqwait);
  X_UNLOCK (reqlock);

  X_LOCK (wrklock);
  --started;
  X_UNLOCK (wrklock);
}

static void set_max_idle (int nthreads)
{
  if (WORDACCESS_UNSAFE) X_LOCK   (reqlock);
  max_idle = nthreads <= 0 ? 1 : nthreads;
  if (WORDACCESS_UNSAFE) X_UNLOCK (reqlock);
}

static void min_parallel (int nthreads)
{
  if (wanted < nthreads)
    wanted = nthreads;
}

static void max_parallel (int nthreads)
{
  if (wanted > nthreads)
    wanted = nthreads;

  while (started > wanted)
    end_thread ();
}

static void poll_wait (void)
{
  fd_set rfd;

  while (nreqs)
    {
      int size;
      if (WORDACCESS_UNSAFE) X_LOCK   (reslock);
      size = res_queue.size;
      if (WORDACCESS_UNSAFE) X_UNLOCK (reslock);

      if (size)
        return;

      maybe_start_thread ();

      FD_ZERO (&rfd);
      FD_SET (respipe [0], &rfd);

      PerlSock_select (respipe [0] + 1, &rfd, 0, 0, 0);
    }
}

static int poll_cb (void)
{
  dSP;
  int count = 0;
  int maxreqs = max_poll_reqs;
  int do_croak = 0;
  struct timeval tv_start, tv_now;
  bdb_req req;

  if (max_poll_time)
    gettimeofday (&tv_start, 0);

  for (;;)
    {
      for (;;)
        {
          maybe_start_thread ();

          X_LOCK (reslock);
          req = reqq_shift (&res_queue);

          if (req)
            {
              --npending;

              if (!res_queue.size)
                {
                  /* read any signals sent by the worker threads */
                  char buf [4];
                  while (respipe_read (respipe [0], buf, 4) == 4)
                    ;
                }
            }

          X_UNLOCK (reslock);

          if (!req)
            break;

          --nreqs;

          if (!req_invoke (req))
            {
              req_free (req);
              croak (0);
            }

          count++;

          req_free (req);

          if (maxreqs && !--maxreqs)
            break;

          if (max_poll_time)
            {
              gettimeofday (&tv_now, 0);

              if (tvdiff (&tv_start, &tv_now) >= max_poll_time)
                break;
            }
        }

      if (nreqs <= max_outstanding)
        break;

      poll_wait ();

      ++maxreqs;
    }

  return count;
}

/*****************************************************************************/

X_THREAD_PROC (bdb_proc)
{
  bdb_req req;
  struct timespec ts;
  worker *self = (worker *)thr_arg;

  /* try to distribute timeouts somewhat evenly */
  ts.tv_nsec = ((unsigned long)self & 1023UL) * (1000000000UL / 1024UL);

  for (;;)
    {
      ts.tv_sec  = time (0) + IDLE_TIMEOUT;

      X_LOCK (reqlock);

      for (;;)
        {
          self->req = req = reqq_shift (&req_queue);

          if (req)
            break;

          ++idle;

          if (X_COND_TIMEDWAIT (reqwait, reqlock, ts)
              == ETIMEDOUT)
            {
              if (idle > max_idle)
                {
                  --idle;
                  X_UNLOCK (reqlock);
                  X_LOCK (wrklock);
                  --started;
                  X_UNLOCK (wrklock);
                  goto quit;
                }

              /* we are allowed to idle, so do so without any timeout */
              X_COND_WAIT (reqwait, reqlock);
              ts.tv_sec  = time (0) + IDLE_TIMEOUT;
            }

          --idle;
        }

      --nready;

      X_UNLOCK (reqlock);
     
      switch (req->type)
        {
          case REQ_QUIT:
            req->result = ENOSYS;
            goto quit;

          case REQ_ENV_OPEN:
            req->result = req->env->open (req->env, req->buf1, req->uint1, req->int1);
            break;

          case REQ_ENV_CLOSE:
            req->result = req->env->close (req->env, req->uint1);
            break;

          case REQ_ENV_TXN_CHECKPOINT:
            req->result = req->env->txn_checkpoint (req->env, req->uint1, req->int1, req->uint2);
            break;

          case REQ_ENV_LOCK_DETECT:
            req->result = req->env->lock_detect (req->env, req->uint1, req->uint2, &req->int1);
            break;

          case REQ_ENV_MEMP_SYNC:
            req->result = req->env->memp_sync (req->env, 0);
            break;

          case REQ_ENV_MEMP_TRICKLE:
            req->result = req->env->memp_trickle (req->env, req->int1, &req->int2);
            break;

          case REQ_ENV_DBREMOVE:
            req->result = req->env->dbremove (req->env, req->txn, req->buf1, req->buf2, req->uint1);
            break;

          case REQ_ENV_DBRENAME:
            req->result = req->env->dbrename (req->env, req->txn, req->buf1, req->buf2, req->buf3, req->uint1);
            break;

          case REQ_DB_OPEN:
            req->result = req->db->open (req->db, req->txn, req->buf1, req->buf2, req->int1, req->uint1, req->int2);
            break;

          case REQ_DB_CLOSE:
            req->result = req->db->close (req->db, req->uint1);
            break;

          case REQ_DB_COMPACT:
            req->result = req->db->compact (req->db, req->txn, &req->dbt1, &req->dbt2, 0, req->uint1, 0);
            break;

          case REQ_DB_SYNC:
            req->result = req->db->sync (req->db, req->uint1);
            break;

          case REQ_DB_UPGRADE:
            req->result = req->db->upgrade (req->db, req->buf1, req->uint1);
            break;

          case REQ_DB_PUT:
            req->result = req->db->put (req->db, req->txn, &req->dbt1, &req->dbt2, req->uint1);
            break;

#if DB_VERSION_MINOR >= 6
          case REQ_DB_EXISTS:
            req->result = req->db->exists (req->db, req->txn, &req->dbt1, req->uint1);
            break;
#endif
          case REQ_DB_GET:
            req->result = req->db->get (req->db, req->txn, &req->dbt1, &req->dbt3, req->uint1);
            break;

          case REQ_DB_PGET:
            req->result = req->db->pget (req->db, req->txn, &req->dbt1, &req->dbt2, &req->dbt3, req->uint1);
            break;

          case REQ_DB_DEL:
            req->result = req->db->del (req->db, req->txn, &req->dbt1, req->uint1);
            break;

          case REQ_DB_KEY_RANGE:
            req->result = req->db->key_range (req->db, req->txn, &req->dbt1, &req->key_range, req->uint1);
            break;

          case REQ_TXN_COMMIT:
            req->result = req->txn->commit (req->txn, req->uint1);
            break;

          case REQ_TXN_ABORT:
            req->result = req->txn->abort (req->txn);
            break;

          case REQ_TXN_FINISH:
            if (req->txn->flags & TXN_DEADLOCK)
              {
                req->result = req->txn->abort (req->txn);
                if (!req->result)
                  req->result = DB_LOCK_DEADLOCK;
              }
            else
              req->result = req->txn->commit (req->txn, req->uint1);
            break;

          case REQ_C_CLOSE:
            req->result = req->dbc->c_close (req->dbc);
            break;

          case REQ_C_COUNT:
            {
              db_recno_t recno;
              req->result = req->dbc->c_count (req->dbc, &recno, req->uint1);
              req->uv1 = recno;
            }
            break;

          case REQ_C_PUT:
            req->result = req->dbc->c_put (req->dbc, &req->dbt1, &req->dbt2, req->uint1);
            break;

          case REQ_C_GET:
            req->result = req->dbc->c_get (req->dbc, &req->dbt1, &req->dbt3, req->uint1);
            break;

          case REQ_C_PGET:
            req->result = req->dbc->c_pget (req->dbc, &req->dbt1, &req->dbt2, &req->dbt3, req->uint1);
            break;

          case REQ_C_DEL:
            req->result = req->dbc->c_del (req->dbc, req->uint1);
            break;

          case REQ_SEQ_OPEN:
            req->result = req->seq->open (req->seq, req->txn, &req->dbt1, req->uint1);
            break;

          case REQ_SEQ_CLOSE:
            req->result = req->seq->close (req->seq, req->uint1);
            break;

          case REQ_SEQ_GET:
            req->result = req->seq->get (req->seq, req->txn, req->int1, &req->seq_t, req->uint1);
            break;

          case REQ_SEQ_REMOVE:
            req->result = req->seq->remove (req->seq, req->txn, req->uint1);
            break;

          default:
            req->result = ENOSYS;
            break;
        }

      if (req->txn && (req->result > 0 || req->result == DB_LOCK_NOTGRANTED))
        req->txn->flags |= TXN_DEADLOCK;

      X_LOCK (reslock);

      ++npending;

      if (!reqq_push (&res_queue, req))
        /* write a dummy byte to the pipe so fh becomes ready */
        respipe_write (respipe_osf [1], (const void *)&respipe_osf, 1);

      self->req = 0;
      worker_clear (self);

      X_UNLOCK (reslock);
    }

quit:
  X_LOCK (wrklock);
  worker_free (self);
  X_UNLOCK (wrklock);

  return 0;
}

/*****************************************************************************/

static void atfork_prepare (void)
{
  X_LOCK (wrklock);
  X_LOCK (reqlock);
  X_LOCK (reslock);
}

static void atfork_parent (void)
{
  X_UNLOCK (reslock);
  X_UNLOCK (reqlock);
  X_UNLOCK (wrklock);
}

static void atfork_child (void)
{
  bdb_req prv;

  while (prv = reqq_shift (&req_queue))
    req_free (prv);

  while (prv = reqq_shift (&res_queue))
    req_free (prv);

  while (wrk_first.next != &wrk_first)
    {
      worker *wrk = wrk_first.next;

      if (wrk->req)
        req_free (wrk->req);

      worker_clear (wrk);
      worker_free (wrk);
    }

  started  = 0;
  idle     = 0;
  nreqs    = 0;
  nready   = 0;
  npending = 0;

  create_respipe ();

  atfork_parent ();
}

#define dREQ(reqtype)						\
  bdb_req req;							\
  int req_pri = next_pri;					\
  next_pri = DEFAULT_PRI + PRI_BIAS;				\
								\
  if (callback && SvOK (callback))				\
    croak ("callback has illegal type or extra arguments");	\
								\
  Newz (0, req, 1, bdb_cb);	        			\
  if (!req)							\
    croak ("out of memory during bdb_req allocation");		\
								\
  req->callback = cb ? SvREFCNT_inc (cb) : 0;			\
  req->type = (reqtype); 					\
  req->pri = req_pri

#define REQ_SEND						\
  req_send (req)

#define SvPTR(var, arg, type, class, nullok)                   			\
  if (!SvOK (arg))								\
    {										\
      if (nullok != 1)								\
        croak (# var " must be a " # class " object, not undef");		\
										\
      (var) = 0;								\
    }										\
  else if (sv_derived_from ((arg), # class))                    		\
    {                                                           		\
      IV tmp = SvIV ((SV*) SvRV (arg));                         		\
      (var) = INT2PTR (type, tmp);                              		\
      if (!var && nullok != 2)									\
        croak (# var " is not a valid " # class " object anymore");		\
    }                                                           		\
  else                                                          		\
    croak (# var " is not of type " # class);

static void
ptr_nuke (SV *sv)
{
  assert (SvROK (sv));
  sv_setiv (SvRV (sv), 0);
}

static int
errno_get (pTHX_ SV *sv, MAGIC *mg)
{
  if (*mg->mg_ptr == '!') // should always be the case
    if (-30999 <= errno && errno <= -30800)
      {
        sv_setnv (sv, (NV)errno);
        sv_setpv (sv, db_strerror (errno));
        SvNOK_on (sv); /* what a wonderful hack! */
                       // ^^^ copied from perl sources
        return 0;
      }

  return PL_vtbl_sv.svt_get (aTHX_ sv, mg);
}

static MGVTBL vtbl_errno;

// this wonderful hack :( patches perl's $! variable to support our errno values
static void
patch_errno (void)
{
  SV *sv;
  MAGIC *mg;

  if (!(sv = get_sv ("!", 1)))
    return;

  if (!(mg = mg_find (sv, PERL_MAGIC_sv)))
    return;

  if (mg->mg_virtual != &PL_vtbl_sv)
    return;

  vtbl_errno = PL_vtbl_sv;
  vtbl_errno.svt_get = errno_get;
  mg->mg_virtual = &vtbl_errno;
}

#if __GNUC__ >= 4
# define noinline                   __attribute__ ((noinline))
#else
# define noinline
#endif

static noinline SV *
pop_callback (I32 *ritems, SV *sv)
{
  if (SvROK (sv))
    {
      HV *st;
      GV *gvp;
      CV *cv;
      const char *name;

      /* forgive me */
      if (SvTYPE (SvRV (sv)) == SVt_PVMG
          && (st = SvSTASH (SvRV (sv)))
          && (name = HvNAME_get (st))
          && (name [0] == 'B' && name [1] == 'D' && name [2] == 'B' && name [3] == ':'))
        return 0;

      if ((cv = sv_2cv (sv, &st, &gvp, 0)))
        {
          --*ritems;
          return (SV *)cv;
        }
    }

  return 0;
}

#define CALLBACK SV *cb = pop_callback (&items, ST (items - 1));

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 1107 "BDB.c"

XS(XS_BDB_max_poll_reqs); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_max_poll_reqs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::max_poll_reqs", "nreqs");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nreqs = (int)SvIV(ST(0));
#line 1312 "BDB.xs"
        max_poll_reqs = nreqs;
#line 1124 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_max_poll_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_max_poll_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::max_poll_time", "nseconds");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	nseconds = (double)SvNV(ST(0));
#line 1318 "BDB.xs"
        max_poll_time = nseconds * AIO_TICKS;
#line 1145 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_min_parallel); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_min_parallel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::min_parallel", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));

	min_parallel(nthreads);
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_max_parallel); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_max_parallel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::max_parallel", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));

	max_parallel(nthreads);
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_max_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_max_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::max_idle", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));
#line 1332 "BDB.xs"
        set_max_idle (nthreads);
#line 1206 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_max_outstanding); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_max_outstanding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::max_outstanding", "maxreqs");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	int	maxreqs = (int)SvIV(ST(0));
#line 1338 "BDB.xs"
        RETVAL = max_outstanding;
        max_outstanding = maxreqs;
#line 1230 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_dbreq_pri); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_dbreq_pri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::dbreq_pri", "pri= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	int	pri;

	if (items < 1)
	    pri = 0;
	else {
	    pri = (int)SvIV(ST(0));
	}
#line 1347 "BDB.xs"
	RETVAL = next_pri - PRI_BIAS;
	if (items > 0)
	  {
	    if (pri < PRI_MIN) pri = PRI_MIN;
	    if (pri > PRI_MAX) pri = PRI_MAX;
	    next_pri = pri + PRI_BIAS;
	  }
#line 1266 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_dbreq_nice); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_dbreq_nice)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::dbreq_nice", "nice= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nice;

	if (items < 1)
	    nice = 0;
	else {
	    nice = (int)SvIV(ST(0));
	}
#line 1360 "BDB.xs"
	nice = next_pri - nice;
	if (nice < PRI_MIN) nice = PRI_MIN;
	if (nice > PRI_MAX) nice = PRI_MAX;
	next_pri = nice + PRI_BIAS;
#line 1297 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::flush", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1369 "BDB.xs"
        while (nreqs)
          {
            poll_wait ();
            poll_cb ();
          }
#line 1321 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_poll); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_poll)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::poll", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1379 "BDB.xs"
        poll_wait ();
        RETVAL = poll_cb ();
#line 1344 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_poll_fileno); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_poll_fileno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::poll_fileno", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1388 "BDB.xs"
        RETVAL = respipe [0];
#line 1367 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_poll_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_poll_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1396 "BDB.xs"
        RETVAL = poll_cb ();
#line 1388 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_poll_wait); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_poll_wait)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::poll_wait", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1404 "BDB.xs"
        poll_wait ();
#line 1409 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_nreqs); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_nreqs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::nreqs", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1410 "BDB.xs"
        RETVAL = nreqs;
#line 1431 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_nready); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_nready)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::nready", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1418 "BDB.xs"
        RETVAL = get_nready ();
#line 1454 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_npending); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_npending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::npending", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1426 "BDB.xs"
        RETVAL = get_npending ();
#line 1477 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_nthreads); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_nthreads)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::nthreads", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1434 "BDB.xs"
        if (WORDACCESS_UNSAFE) X_LOCK   (wrklock);
        RETVAL = started;
        if (WORDACCESS_UNSAFE) X_UNLOCK (wrklock);
#line 1502 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB_set_sync_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_set_sync_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::set_sync_prepare", "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	cb = ST(0);
#line 1444 "BDB.xs"
        SvREFCNT_dec (prepare_cb);
        prepare_cb = newSVsv (cb);
#line 1525 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_strerror); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_strerror)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::strerror", "errorno= errno");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	RETVAL;
	dXSTARG;
	int	errorno;

	if (items < 1)
	    errorno = errno;
	else {
	    errorno = (int)SvIV(ST(0));
	}
#line 1451 "BDB.xs"
        RETVAL = db_strerror (errorno);
#line 1554 "BDB.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_BDB__on_next_submit); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__on_next_submit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::_on_next_submit", "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	cb = ST(0);
#line 1457 "BDB.xs"
        SvREFCNT_dec (on_next_submit);
        on_next_submit = SvOK (cb) ? newSVsv (cb) : 0;
#line 1577 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_create", "env_flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_ENV *	RETVAL;
	U32	env_flags;

	if (items < 1)
	    env_flags = 0;
	else {
	    env_flags = (unsigned long)SvUV(ST(0));
	}
#line 1463 "BDB.xs"
{
        errno = db_env_create (&RETVAL, env_flags);
        if (errno)
          croak ("db_env_create: %s", db_strerror (errno));

        if (0)
          {
            RETVAL->set_errcall (RETVAL, debug_errcall);
            RETVAL->set_msgcall (RETVAL, debug_msgcall);
          }
}
#line 1615 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Env", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_BDB_db_env_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_open", "env, db_home, open_flags, mode, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1480 "BDB.xs"
        CALLBACK
#line 1638 "BDB.c"
	DB_ENV *	env;
	bdb_filename	db_home;
	U32	open_flags = (unsigned long)SvUV(ST(2));
	int	mode = (int)SvIV(ST(3));
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

        (db_home) = get_bdb_filename (ST(1));

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1482 "BDB.xs"
{
        dREQ (REQ_ENV_OPEN);
        req->env   = env;
        req->uint1 = open_flags | DB_THREAD;
        req->int1  = mode;
        req->buf1  = strdup_ornull (db_home);
        REQ_SEND;
}
#line 1663 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_close", "env, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1494 "BDB.xs"
        CALLBACK
#line 1683 "BDB.c"
	DB_ENV *	env;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1496 "BDB.xs"
{
	dREQ (REQ_ENV_CLOSE);
        req->env   = env;
        req->uint1 = flags;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 1709 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_txn_checkpoint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_txn_checkpoint", "env, kbyte= 0, min= 0, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1507 "BDB.xs"
        CALLBACK
#line 1729 "BDB.c"
	DB_ENV *	env;
	U32	kbyte;
	U32	min;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    kbyte = 0;
	else {
	    kbyte = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    min = 0;
	else {
	    min = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1509 "BDB.xs"
{
        dREQ (REQ_ENV_TXN_CHECKPOINT);
        req->env   = env;
        req->uint1 = kbyte;
        req->int1  = min;
        req->uint2 = flags;
        REQ_SEND;
}
#line 1770 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_lock_detect); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_lock_detect)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_lock_detect", "env, flags= 0, atype= DB_LOCK_DEFAULT, dummy= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1521 "BDB.xs"
        CALLBACK
#line 1790 "BDB.c"
	DB_ENV *	env;
	U32	flags;
	U32	atype;
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    atype = DB_LOCK_DEFAULT;
	else {
	    atype = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    dummy = 0;
	else {
	    dummy = ST(3);
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1523 "BDB.xs"
{
        dREQ (REQ_ENV_LOCK_DETECT);
        req->env   = env;
        req->uint1 = flags;
        req->uint2 = atype;
        /* req->int2  = 0; dummy */
        REQ_SEND;
}
#line 1831 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_memp_sync); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_memp_sync)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_memp_sync", "env, dummy= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1535 "BDB.xs"
        CALLBACK
#line 1851 "BDB.c"
	DB_ENV *	env;
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    dummy = 0;
	else {
	    dummy = ST(1);
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1537 "BDB.xs"
{
        dREQ (REQ_ENV_MEMP_SYNC);
        req->env  = env;
        REQ_SEND;
}
#line 1875 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_memp_trickle); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_memp_trickle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_memp_trickle", "env, percent, dummy= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1546 "BDB.xs"
        CALLBACK
#line 1895 "BDB.c"
	DB_ENV *	env;
	int	percent = (int)SvIV(ST(1));
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 3)
	    dummy = 0;
	else {
	    dummy = ST(2);
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3);
	}
#line 1548 "BDB.xs"
{
        dREQ (REQ_ENV_MEMP_TRICKLE);
        req->env  = env;
        req->int1 = percent;
        REQ_SEND;
}
#line 1921 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_dbremove); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_dbremove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_dbremove", "env, txnid, file, database, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1558 "BDB.xs"
        CALLBACK
#line 1941 "BDB.c"
	DB_ENV *	env;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

        SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);

        (file) = get_bdb_filename (ST(2));

        (database) = get_bdb_filename (ST(3));

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1560 "BDB.xs"
{
	dREQ (REQ_ENV_DBREMOVE);
        req->env   = env;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->uint1 = flags;
        REQ_SEND;
}
#line 1977 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_env_dbrename); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_env_dbrename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_env_dbrename", "env, txnid, file, database, newname, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1572 "BDB.xs"
        CALLBACK
#line 1997 "BDB.c"
	DB_ENV *	env;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	bdb_filename	newname;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

        SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);

        (file) = get_bdb_filename (ST(2));

        (database) = get_bdb_filename (ST(3));

        (newname) = get_bdb_filename (ST(4));

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(5));
	}

	if (items < 7)
	    callback = 0;
	else {
	    callback = ST(6);
	}
#line 1574 "BDB.xs"
{
	dREQ (REQ_ENV_DBRENAME);
        req->env   = env;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->buf3  = strdup_ornull (newname);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2037 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_create", "env= 0, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB *	RETVAL;
	DB_ENV *	env;
	U32	flags;

	if (items < 1)
	    env = 0;
	else {
	SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
	}

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}
#line 1587 "BDB.xs"
{
        errno = db_create (&RETVAL, env, flags);
        if (errno)
          croak ("db_create: %s", db_strerror (errno));

        if (RETVAL)
          RETVAL->app_private = (void *)newSVsv (ST (0));
}
#line 2079 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Db", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_BDB_db_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 7 || items > 8)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_open", "db, txnid, file, database, type, flags, mode, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1601 "BDB.xs"
        CALLBACK
#line 2102 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	int	type = (int)SvIV(ST(4));
	U32	flags = (unsigned long)SvUV(ST(5));
	int	mode = (int)SvIV(ST(6));
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);

        (file) = get_bdb_filename (ST(2));

        (database) = get_bdb_filename (ST(3));

	if (items < 8)
	    callback = 0;
	else {
	    callback = ST(7);
	}
#line 1603 "BDB.xs"
{
        dREQ (REQ_DB_OPEN);
        req->db    = db;
        req->txn   = txnid;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->int1  = type;
        req->uint1 = flags | DB_THREAD;
        req->int2  = mode;
        REQ_SEND;
}
#line 2137 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_close", "db, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1618 "BDB.xs"
        CALLBACK
#line 2157 "BDB.c"
	DB *	db;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1620 "BDB.xs"
{
        dREQ (REQ_DB_CLOSE);
        req->db    = db;
        req->uint1 = flags;
        req->sv1   = (SV *)db->app_private;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 2184 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_compact); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_compact)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 8)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_compact", "db, txn= 0, start= 0, stop= 0, unused1= 0, flags= DB_FREE_SPACE, unused2= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1632 "BDB.xs"
        CALLBACK
#line 2204 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	start;
	SV *	stop;
	SV *	unused1;
	U32	flags;
	SV *	unused2;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 2)
	    txn = 0;
	else {
	SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);
	}

	if (items < 3)
	    start = 0;
	else {
	    start = ST(2);
	}

	if (items < 4)
	    stop = 0;
	else {
	    stop = ST(3);
	}

	if (items < 5)
	    unused1 = 0;
	else {
	    unused1 = ST(4);
	}

	if (items < 6)
	    flags = DB_FREE_SPACE;
	else {
	    flags = (unsigned long)SvUV(ST(5));
	}

	if (items < 7)
	    unused2 = 0;
	else {
	    unused2 = ST(6);
	}

	if (items < 8)
	    callback = 0;
	else {
	    callback = ST(7);
	}
#line 1634 "BDB.xs"
{
        dREQ (REQ_DB_COMPACT);
        req->db    = db;
        req->txn   = txn;
        sv_to_dbt (&req->dbt1, start);
        sv_to_dbt (&req->dbt2, stop);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2267 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_sync); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_sync)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_sync", "db, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1647 "BDB.xs"
        CALLBACK
#line 2287 "BDB.c"
	DB *	db;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1649 "BDB.xs"
{
        dREQ (REQ_DB_SYNC);
        req->db    = db;
        req->uint1 = flags;
        REQ_SEND;
}
#line 2312 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_upgrade)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_upgrade", "db, file, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1659 "BDB.xs"
        CALLBACK
#line 2332 "BDB.c"
	DB *	db;
	bdb_filename	file;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        (file) = get_bdb_filename (ST(1));

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3);
	}
#line 1661 "BDB.xs"
{
        dREQ (REQ_DB_SYNC);
        req->db    = db;
        req->buf1  = strdup (file);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2361 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_key_range); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_key_range)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_key_range", "db, txn, key, key_range, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1672 "BDB.xs"
        CALLBACK
#line 2381 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	SV *	key_range = ST(3);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1674 "BDB.xs"
{
        dREQ (REQ_DB_KEY_RANGE);
        req->db    = db;
        req->txn   = txn;
        sv_to_dbt (&req->dbt1, key);
        req->uint1 = flags;
        req->sv1   = SvREFCNT_inc (key_range); SvREADONLY_on (key_range);
        REQ_SEND;
}
#line 2414 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_put); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_put)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_put", "db, txn, key, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1687 "BDB.xs"
        CALLBACK
#line 2434 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	SV *	data = ST(3);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1689 "BDB.xs"
{
        dREQ (REQ_DB_PUT);
        req->db    = db;
        req->txn   = txn;
        sv_to_dbt (&req->dbt1, key);
        sv_to_dbt (&req->dbt2, data);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2467 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DB_VERSION_MINOR >= 6
#define XSubPPtmpAAAA 1


XS(XS_BDB_db_exists); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_exists)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_exists", "db, txn, key, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1704 "BDB.xs"
        CALLBACK
#line 2490 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1706 "BDB.xs"
{
        dREQ (REQ_DB_EXISTS);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 2521 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS(XS_BDB_db_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_get", "db, txn, key, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1720 "BDB.xs"
        CALLBACK
#line 2542 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	SV *	data = ST(3);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1722 "BDB.xs"
        if (SvREADONLY (data))
          croak ("can't modify read-only data scalar in db_get");
{
        dREQ (REQ_DB_GET);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        req->dbt3.flags = DB_DBT_MALLOC;
        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 2578 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_pget); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_pget)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_pget", "db, txn, key, pkey, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1738 "BDB.xs"
        CALLBACK
#line 2598 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	SV *	pkey = ST(3);
	SV *	data = ST(4);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(5));
	}

	if (items < 7)
	    callback = 0;
	else {
	    callback = ST(6);
	}
#line 1740 "BDB.xs"
        if (SvREADONLY (data))
          croak ("can't modify read-only data scalar in db_pget");
{
        dREQ (REQ_DB_PGET);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        sv_to_dbt (&req->dbt2, pkey);
        req->dbt3.flags = DB_DBT_MALLOC;
        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 2636 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_del)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_del", "db, txn, key, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1757 "BDB.xs"
        CALLBACK
#line 2656 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2);
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

        SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1759 "BDB.xs"
{
        dREQ (REQ_DB_DEL);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 2687 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_txn_commit); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_txn_commit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_txn_commit", "txn, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1771 "BDB.xs"
        CALLBACK
#line 2707 "BDB.c"
	DB_TXN *	txn;
	U32	flags;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1773 "BDB.xs"
{
        dREQ (REQ_TXN_COMMIT);
        req->txn   = txn;
        req->uint1 = flags;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 2733 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_txn_abort); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_txn_abort)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_txn_abort", "txn, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1784 "BDB.xs"
        CALLBACK
#line 2753 "BDB.c"
	DB_TXN *	txn;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 0);

	if (items < 2)
	    callback = 0;
	else {
	    callback = ST(1);
	}
#line 1786 "BDB.xs"
{
        dREQ (REQ_TXN_ABORT);
        req->txn   = txn;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 2771 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_txn_finish); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_txn_finish)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_txn_finish", "txn, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1796 "BDB.xs"
        CALLBACK
#line 2791 "BDB.c"
	DB_TXN *	txn;
	U32	flags;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1798 "BDB.xs"
{
        dREQ (REQ_TXN_FINISH);
        req->txn   = txn;
        req->uint1 = flags;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 2817 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_close", "dbc, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1809 "BDB.xs"
        CALLBACK
#line 2837 "BDB.c"
	DBC *	dbc;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 2)
	    callback = 0;
	else {
	    callback = ST(1);
	}
#line 1811 "BDB.xs"
{
        dREQ (REQ_C_CLOSE);
        req->dbc = dbc;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 2855 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_count", "dbc, count, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1821 "BDB.xs"
        CALLBACK
#line 2875 "BDB.c"
	DBC *	dbc;
	SV *	count = ST(1);
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3);
	}
#line 1823 "BDB.xs"
{
        dREQ (REQ_C_COUNT);
        req->dbc = dbc;
        req->sv1 = SvREFCNT_inc (count);
        REQ_SEND;
}
#line 2901 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_put); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_put)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_put", "dbc, key, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1833 "BDB.xs"
        CALLBACK
#line 2921 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1);
	SV *	data = ST(2);
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1835 "BDB.xs"
{
        dREQ (REQ_C_PUT);
        req->dbc   = dbc;
        sv_to_dbt (&req->dbt1, key);
        sv_to_dbt (&req->dbt2, data);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2950 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_get", "dbc, key, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1847 "BDB.xs"
        CALLBACK
#line 2970 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1);
	SV *	data = ST(2);
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1849 "BDB.xs"
{
        dREQ (REQ_C_GET);
        req->dbc   = dbc;
        req->uint1 = flags;
        if ((flags & DB_SET) == DB_SET
            || (flags & DB_SET_RANGE) == DB_SET_RANGE)
          sv_to_dbt (&req->dbt1, key);
        else
          req->dbt1.flags = DB_DBT_MALLOC;

        req->sv1 = SvREFCNT_inc (key); SvREADONLY_on (key);

        if ((flags & DB_GET_BOTH) == DB_GET_BOTH
            || (flags & DB_GET_BOTH_RANGE) == DB_GET_BOTH_RANGE)
          sv_to_dbt (&req->dbt3, data);
        else
          req->dbt3.flags = DB_DBT_MALLOC;

        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 3012 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_pget); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_pget)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_pget", "dbc, key, pkey, data, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1874 "BDB.xs"
        CALLBACK
#line 3032 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1);
	SV *	pkey = ST(2);
	SV *	data = ST(3);
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1876 "BDB.xs"
{
        dREQ (REQ_C_PGET);
        req->dbc   = dbc;
        req->uint1 = flags;
        if ((flags & DB_SET) == DB_SET
            || (flags & DB_SET_RANGE) == DB_SET_RANGE)
          sv_to_dbt (&req->dbt1, key);
        else
          req->dbt1.flags = DB_DBT_MALLOC;

        req->sv1 = SvREFCNT_inc (key); SvREADONLY_on (key);

        req->dbt2.flags = DB_DBT_MALLOC;
        req->sv2 = SvREFCNT_inc (pkey); SvREADONLY_on (pkey);

        if ((flags & DB_GET_BOTH) == DB_GET_BOTH
            || (flags & DB_GET_BOTH_RANGE) == DB_GET_BOTH_RANGE)
          sv_to_dbt (&req->dbt3, data);
        else
          req->dbt3.flags = DB_DBT_MALLOC;

        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 3078 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_c_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_c_del)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_c_del", "dbc, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1904 "BDB.xs"
        CALLBACK
#line 3098 "BDB.c"
	DBC *	dbc;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1906 "BDB.xs"
{
        dREQ (REQ_C_DEL);
        req->dbc   = dbc;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3123 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_sequence_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_sequence_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_sequence_open", "seq, txnid, key, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1917 "BDB.xs"
        CALLBACK
#line 3143 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	SV *	key = ST(2);
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);

        SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4);
	}
#line 1919 "BDB.xs"
{
        dREQ (REQ_SEQ_OPEN);
        req->seq   = seq;
        req->txn   = txnid;
        req->uint1 = flags | DB_THREAD;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 3174 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_sequence_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_sequence_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_sequence_close", "seq, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1931 "BDB.xs"
        CALLBACK
#line 3194 "BDB.c"
	DB_SEQUENCE *	seq;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2);
	}
#line 1933 "BDB.xs"
{
        dREQ (REQ_SEQ_CLOSE);
        req->seq   = seq;
        req->uint1 = flags;
        REQ_SEND;
        ptr_nuke (ST (0));
}
#line 3220 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_sequence_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_sequence_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_sequence_get", "seq, txnid, delta, seq_value, flags= DB_TXN_NOSYNC, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1944 "BDB.xs"
        CALLBACK
#line 3240 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	int	delta = (int)SvIV(ST(2));
	SV *	seq_value = ST(3);
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);

        SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);

	if (items < 5)
	    flags = DB_TXN_NOSYNC;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5);
	}
#line 1946 "BDB.xs"
{
        dREQ (REQ_SEQ_GET);
        req->seq   = seq;
        req->txn   = txnid;
        req->int1  = delta;
        req->uint1 = flags;
        req->sv1   = SvREFCNT_inc (seq_value); SvREADONLY_on (seq_value);
        REQ_SEND;
}
#line 3273 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB_db_sequence_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB_db_sequence_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::db_sequence_remove", "seq, txnid= 0, flags= 0, callback= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1959 "BDB.xs"
        CALLBACK
#line 3293 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);

	if (items < 2)
	    txnid = 0;
	else {
	SvPTR (txnid, ST(1), DB_TXN *, BDB::Txn, 1);
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3);
	}
#line 1961 "BDB.xs"
{
        dREQ (REQ_SEQ_REMOVE);
        req->seq   = seq;
        req->txn   = txnid;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3326 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Env_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::DESTROY", "env");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_ENV_ornuked *	env;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 2);
#line 1975 "BDB.xs"
        if (env)
          env->close (env, 0);
#line 3350 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Env_set_data_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_data_dir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_data_dir", "env, dir");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 1980 "BDB.xs"
        RETVAL = env->set_data_dir (env, dir);
#line 3376 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_tmp_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_tmp_dir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_tmp_dir", "env, dir");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 1986 "BDB.xs"
        RETVAL = env->set_tmp_dir (env, dir);
#line 3403 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lg_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lg_dir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lg_dir", "env, dir");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 1992 "BDB.xs"
        RETVAL = env->set_lg_dir (env, dir);
#line 3430 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_shm_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_shm_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_shm_key", "env, shm_key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	long	shm_key = (long)SvIV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 1998 "BDB.xs"
        RETVAL = env->set_shm_key (env, shm_key);
#line 3457 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_cachesize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_cachesize", "env, gbytes, bytes, ncache= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	gbytes = (unsigned long)SvUV(ST(1));
	U32	bytes = (unsigned long)SvUV(ST(2));
	int	ncache;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 4)
	    ncache = 0;
	else {
	    ncache = (int)SvIV(ST(3));
	}
#line 2004 "BDB.xs"
        RETVAL = env->set_cachesize (env, gbytes, bytes, ncache);
#line 3492 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_flags", "env, flags, onoff= 1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	flags = (unsigned long)SvUV(ST(1));
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2));
	}
#line 2010 "BDB.xs"
        RETVAL = env->set_flags (env, flags, onoff);
#line 3526 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if DB_VERSION_MINOR >= 7
#define XSubPPtmpAAAB 1


XS(XS_BDB__Env_set_intermediate_dir_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_intermediate_dir_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_intermediate_dir_mode", "env, mode");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	mode = (const char *)SvPV_nolen(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2018 "BDB.xs"
        RETVAL = env->set_intermediate_dir_mode (env, mode);
#line 3556 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_log_set_config); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_log_set_config)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::log_set_config", "env, flags, onoff= 1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	flags = (unsigned long)SvUV(ST(1));
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2));
	}
#line 2024 "BDB.xs"
        RETVAL = env->log_set_config (env, flags, onoff);
#line 3590 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS(XS_BDB__Env_set_errfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_errfile)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_errfile", "env, errfile= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_ENV *	env;
	FILE *	errfile;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    errfile = 0;
	else {
	    errfile = PerlIO_findFILE(IoIFP(sv_2io(ST(1))));
	}
#line 2033 "BDB.xs"
        env->set_errfile (env, errfile);
#line 3622 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Env_set_msgfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_msgfile)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_msgfile", "env, msgfile= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_ENV *	env;
	FILE *	msgfile;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    msgfile = 0;
	else {
	    msgfile = PerlIO_findFILE(IoIFP(sv_2io(ST(1))));
	}
#line 2037 "BDB.xs"
        env->set_msgfile (env, msgfile);
#line 3652 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Env_set_verbose); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_verbose)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_verbose", "env, which= -1, onoff= 1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	which;
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    which = -1;
	else {
	    which = (unsigned long)SvUV(ST(1));
	}

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2));
	}
#line 2041 "BDB.xs"
        RETVAL = env->set_verbose (env, which, onoff);
#line 3691 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_encrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_encrypt", "env, password, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	password = (const char *)SvPV_nolen(ST(1));
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}
#line 2047 "BDB.xs"
        RETVAL = env->set_encrypt (env, password, flags);
#line 3725 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_timeout", "env, timeout, flags= DB_SET_TXN_TIMEOUT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	NV	timeout = (NV)SvNV(ST(1));
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 3)
	    flags = DB_SET_TXN_TIMEOUT;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}
#line 2053 "BDB.xs"
        RETVAL = env->set_timeout (env, timeout * 1000000, flags);
#line 3759 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_mp_max_openfd); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_mp_max_openfd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_mp_max_openfd", "env, maxopenfd");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	maxopenfd = (int)SvIV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2059 "BDB.xs"
        RETVAL = env->set_mp_max_openfd (env, maxopenfd);
#line 3786 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_mp_max_write); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_mp_max_write)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_mp_max_write", "env, maxwrite, maxwrite_sleep");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	maxwrite = (int)SvIV(ST(1));
	int	maxwrite_sleep = (int)SvIV(ST(2));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2065 "BDB.xs"
        RETVAL = env->set_mp_max_write (env, maxwrite, maxwrite_sleep);
#line 3814 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_mp_mmapsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_mp_mmapsize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_mp_mmapsize", "env, mmapsize_mb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	mmapsize_mb = (int)SvIV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2071 "BDB.xs"
        RETVAL = env->set_mp_mmapsize (env, ((size_t)mmapsize_mb) << 20);
#line 3841 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lk_detect); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lk_detect)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lk_detect", "env, detect= DB_LOCK_DEFAULT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	detect;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    detect = DB_LOCK_DEFAULT;
	else {
	    detect = (unsigned long)SvUV(ST(1));
	}
#line 2077 "BDB.xs"
        RETVAL = env->set_lk_detect (env, detect);
#line 3874 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lk_max_lockers); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lk_max_lockers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lk_max_lockers", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2083 "BDB.xs"
        RETVAL = env->set_lk_max_lockers (env, max);
#line 3901 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lk_max_locks); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lk_max_locks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lk_max_locks", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2089 "BDB.xs"
        RETVAL = env->set_lk_max_locks (env, max);
#line 3928 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lk_max_objects); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lk_max_objects)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lk_max_objects", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2095 "BDB.xs"
        RETVAL = env->set_lk_max_objects (env, max);
#line 3955 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lg_bsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lg_bsize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lg_bsize", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2101 "BDB.xs"
        RETVAL = env->set_lg_bsize (env, max);
#line 3982 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_set_lg_max); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_set_lg_max)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::set_lg_max", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2107 "BDB.xs"
        RETVAL = env->set_lg_max (env, max);
#line 4009 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_mutex_set_max); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_mutex_set_max)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::mutex_set_max", "env, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2113 "BDB.xs"
        RETVAL = env->mutex_set_max (env, max);
#line 4036 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_mutex_set_increment); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_mutex_set_increment)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::mutex_set_increment", "env, increment");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	increment = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2119 "BDB.xs"
        RETVAL = env->mutex_set_increment (env, increment);
#line 4063 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_mutex_set_tas_spins); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_mutex_set_tas_spins)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::mutex_set_tas_spins", "env, tas_spins");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	tas_spins = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2125 "BDB.xs"
        RETVAL = env->mutex_set_tas_spins (env, tas_spins);
#line 4090 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_mutex_set_align); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_mutex_set_align)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::mutex_set_align", "env, align");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	align = (unsigned long)SvUV(ST(1));

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2131 "BDB.xs"
        RETVAL = env->mutex_set_align (env, align);
#line 4117 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Env_txn_begin); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_txn_begin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::txn_begin", "env, parent= 0, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_TXN *	RETVAL;
	DB_ENV *	env;
	DB_TXN_ornull *	parent;
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);

	if (items < 2)
	    parent = 0;
	else {
	SvPTR (parent, ST(1), DB_TXN *, BDB::Txn, 1);
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}
#line 2138 "BDB.xs"
        errno = env->txn_begin (env, parent, &RETVAL, flags);
        if (errno)
          croak ("DB_ENV->txn_begin: %s", db_strerror (errno));
#line 4158 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Txn", (void *)RETVAL);

    }
    XSRETURN(1);
}

#if DB_VERSION_MINOR >= 5
#define XSubPPtmpAAAC 1


XS(XS_BDB__Env_cdsgroup_begin); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Env_cdsgroup_begin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Env::cdsgroup_begin", "env");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_TXN *	RETVAL;
	DB_ENV *	env;

        SvPTR (env, ST(0), DB_ENV *, BDB::Env, 0);
#line 2149 "BDB.xs"
        errno = env->cdsgroup_begin (env, &RETVAL);
        if (errno)
          croak ("DB_ENV->cdsgroup_begin: %s", db_strerror (errno));
#line 4190 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Txn", (void *)RETVAL);

    }
    XSRETURN(1);
}

#endif

XS(XS_BDB__Db_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::DESTROY", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_ornuked *	db;

        SvPTR (db, ST(0), DB *, BDB::Db, 2);
#line 2162 "BDB.xs"
        if (db)
          {
            SV *env = (SV *)db->app_private;
            db->close (db, 0);
            SvREFCNT_dec (env);
          }
#line 4222 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Db_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_cachesize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_cachesize", "db, gbytes, bytes, ncache= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	gbytes = (unsigned long)SvUV(ST(1));
	U32	bytes = (unsigned long)SvUV(ST(2));
	int	ncache;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 4)
	    ncache = 0;
	else {
	    ncache = (int)SvIV(ST(3));
	}
#line 2171 "BDB.xs"
        RETVAL = db->set_cachesize (db, gbytes, bytes, ncache);
#line 4256 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_flags", "db, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	flags = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2177 "BDB.xs"
        RETVAL = db->set_flags (db, flags);
#line 4283 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_encrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_encrypt", "db, password, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	const char *	password = (const char *)SvPV_nolen(ST(1));
	U32	flags = (unsigned long)SvUV(ST(2));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2183 "BDB.xs"
        RETVAL = db->set_encrypt (db, password, flags);
#line 4311 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_lorder); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_lorder)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_lorder", "db, lorder");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	lorder = (int)SvIV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2189 "BDB.xs"
        RETVAL = db->set_lorder (db, lorder);
#line 4338 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_bt_minkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_bt_minkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_bt_minkey", "db, minkey");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	minkey = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2195 "BDB.xs"
        RETVAL = db->set_bt_minkey (db, minkey);
#line 4365 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_re_delim); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_re_delim)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_re_delim", "db, delim");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	delim = (int)SvIV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2201 "BDB.xs"
        RETVAL = db->set_re_delim (db, delim);
#line 4392 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_re_pad); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_re_pad)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_re_pad", "db, re_pad");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	re_pad = (int)SvIV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2207 "BDB.xs"
        RETVAL = db->set_re_pad (db, re_pad);
#line 4419 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_re_source); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_re_source)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_re_source", "db, source");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	char *	source = (char *)SvPV_nolen(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2213 "BDB.xs"
        RETVAL = db->set_re_source (db, source);
#line 4446 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_re_len); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_re_len)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_re_len", "db, re_len");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	re_len = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2219 "BDB.xs"
        RETVAL = db->set_re_len (db, re_len);
#line 4473 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_h_ffactor); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_h_ffactor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_h_ffactor", "db, h_ffactor");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	h_ffactor = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2225 "BDB.xs"
        RETVAL = db->set_h_ffactor (db, h_ffactor);
#line 4500 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_h_nelem); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_h_nelem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_h_nelem", "db, h_nelem");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	h_nelem = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2231 "BDB.xs"
        RETVAL = db->set_h_nelem (db, h_nelem);
#line 4527 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_set_q_extentsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_set_q_extentsize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::set_q_extentsize", "db, extentsize");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	extentsize = (unsigned long)SvUV(ST(1));

        SvPTR (db, ST(0), DB *, BDB::Db, 0);
#line 2237 "BDB.xs"
        RETVAL = db->set_q_extentsize (db, extentsize);
#line 4554 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Db_cursor); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_cursor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::cursor", "db, txn= 0, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DBC *	RETVAL;
	DB *	db;
	DB_TXN_ornull *	txn;
	U32	flags;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 2)
	    txn = 0;
	else {
	SvPTR (txn, ST(1), DB_TXN *, BDB::Txn, 1);
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}
#line 2244 "BDB.xs"
        errno = db->cursor (db, txn, &RETVAL, flags);
        if (errno)
          croak ("DB->cursor: %s", db_strerror (errno));
#line 4595 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Cursor", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_BDB__Db_sequence); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Db_sequence)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Db::sequence", "db, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_SEQUENCE *	RETVAL;
	DB *	db;
	U32	flags;

        SvPTR (db, ST(0), DB *, BDB::Db, 0);

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}
#line 2253 "BDB.xs"
{
        errno = db_sequence_create (&RETVAL, db, flags);
        if (errno)
          croak ("db_sequence_create: %s", db_strerror (errno));
}
#line 4633 "BDB.c"
	ST(0) = sv_newmortal();
	sv_setref_pv (ST(0), "BDB::Sequence", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Txn_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Txn_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Txn::DESTROY", "txn");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_TXN_ornuked *	txn;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 2);
#line 2267 "BDB.xs"
        if (txn)
          txn->abort (txn);
#line 4659 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Txn_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Txn_set_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Txn::set_timeout", "txn, timeout, flags= DB_SET_TXN_TIMEOUT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_TXN *	txn;
	NV	timeout = (NV)SvNV(ST(1));
	U32	flags;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 0);

	if (items < 3)
	    flags = DB_SET_TXN_TIMEOUT;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}
#line 2272 "BDB.xs"
        RETVAL = txn->set_timeout (txn, timeout * 1000000, flags);
#line 4692 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Txn_failed); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Txn_failed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Txn::failed", "txn");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_TXN *	txn;

        SvPTR (txn, ST(0), DB_TXN *, BDB::Txn, 0);
#line 2278 "BDB.xs"
        RETVAL = !!(txn->flags & TXN_DEADLOCK);
#line 4718 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Cursor_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Cursor_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Cursor::DESTROY", "dbc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DBC_ornuked *	dbc;

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 2);
#line 2288 "BDB.xs"
        if (dbc)
          dbc->c_close (dbc);
#line 4743 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DB_VERSION_MINOR >= 6
#define XSubPPtmpAAAD 1


XS(XS_BDB__Cursor_set_priority); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Cursor_set_priority)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Cursor::set_priority", "dbc, priority");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DBC *	dbc;
	int	priority = (int)SvIV(ST(1));

        SvPTR (dbc, ST(0), DBC *, BDB::Cursor, 0);
#line 2295 "BDB.xs"
        dbc->set_priority (dbc, priority);
#line 4772 "BDB.c"
    }
    XSRETURN(1);
}

#endif

XS(XS_BDB__Sequence_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Sequence_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Sequence::DESTROY", "seq");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	DB_SEQUENCE_ornuked *	seq;

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 2);
#line 2304 "BDB.xs"
        if (seq)
          seq->close (seq, 0);
#line 4797 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BDB__Sequence_initial_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Sequence_initial_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Sequence::initial_value", "seq, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	db_seq_t	value = sizeof (IV) > 4 ? SvIV (ST(1)) : SvNV (ST(1));

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);
#line 2309 "BDB.xs"
        RETVAL = seq->initial_value (seq, value);
#line 4823 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Sequence_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Sequence_set_cachesize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Sequence::set_cachesize", "seq, size");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	U32	size = (unsigned long)SvUV(ST(1));

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);
#line 2315 "BDB.xs"
        RETVAL = seq->set_cachesize (seq, size);
#line 4850 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Sequence_set_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Sequence_set_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Sequence::set_flags", "seq, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	U32	flags = (unsigned long)SvUV(ST(1));

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);
#line 2321 "BDB.xs"
        RETVAL = seq->set_flags (seq, flags);
#line 4877 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BDB__Sequence_set_range); /* prototype to pass -Wmissing-prototypes */
XS(XS_BDB__Sequence_set_range)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "BDB::Sequence::set_range", "seq, min, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	db_seq_t	min = sizeof (IV) > 4 ? SvIV (ST(1)) : SvNV (ST(1));
	db_seq_t	max = sizeof (IV) > 4 ? SvIV (ST(2)) : SvNV (ST(2));

        SvPTR (seq, ST(0), DB_SEQUENCE *, BDB::Sequence, 0);
#line 2327 "BDB.xs"
        RETVAL = seq->set_range (seq, min, max);
#line 4905 "BDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_BDB); /* prototype to pass -Wmissing-prototypes */
XS(boot_BDB)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("BDB::max_poll_reqs", XS_BDB_max_poll_reqs, file, "$");
        newXSproto("BDB::max_poll_time", XS_BDB_max_poll_time, file, "$");
        newXSproto("BDB::min_parallel", XS_BDB_min_parallel, file, "$");
        newXSproto("BDB::max_parallel", XS_BDB_max_parallel, file, "$");
        newXSproto("BDB::max_idle", XS_BDB_max_idle, file, "$");
        newXSproto("BDB::max_outstanding", XS_BDB_max_outstanding, file, "$");
        newXSproto("BDB::dbreq_pri", XS_BDB_dbreq_pri, file, ";$");
        newXSproto("BDB::dbreq_nice", XS_BDB_dbreq_nice, file, ";$");
        newXSproto("BDB::flush", XS_BDB_flush, file, "");
        newXSproto("BDB::poll", XS_BDB_poll, file, "");
        newXSproto("BDB::poll_fileno", XS_BDB_poll_fileno, file, "");
        newXSproto("BDB::poll_cb", XS_BDB_poll_cb, file, "");
        newXSproto("BDB::poll_wait", XS_BDB_poll_wait, file, "");
        newXSproto("BDB::nreqs", XS_BDB_nreqs, file, "");
        newXSproto("BDB::nready", XS_BDB_nready, file, "");
        newXSproto("BDB::npending", XS_BDB_npending, file, "");
        newXSproto("BDB::nthreads", XS_BDB_nthreads, file, "");
        newXSproto("BDB::set_sync_prepare", XS_BDB_set_sync_prepare, file, "&");
        newXSproto("BDB::strerror", XS_BDB_strerror, file, ";$");
        newXSproto("BDB::_on_next_submit", XS_BDB__on_next_submit, file, "$");
        newXSproto("BDB::db_env_create", XS_BDB_db_env_create, file, ";$");
        newXSproto("BDB::db_env_open", XS_BDB_db_env_open, file, "$$$$;$");
        newXSproto("BDB::db_env_close", XS_BDB_db_env_close, file, "$;$$");
        newXSproto("BDB::db_env_txn_checkpoint", XS_BDB_db_env_txn_checkpoint, file, "$;$$$$");
        newXSproto("BDB::db_env_lock_detect", XS_BDB_db_env_lock_detect, file, "$;$$$$");
        newXSproto("BDB::db_env_memp_sync", XS_BDB_db_env_memp_sync, file, "$;$$");
        newXSproto("BDB::db_env_memp_trickle", XS_BDB_db_env_memp_trickle, file, "$$;$$");
        newXSproto("BDB::db_env_dbremove", XS_BDB_db_env_dbremove, file, "$$$$;$$");
        newXSproto("BDB::db_env_dbrename", XS_BDB_db_env_dbrename, file, "$$$$$;$$");
        newXSproto("BDB::db_create", XS_BDB_db_create, file, ";$$");
        newXSproto("BDB::db_open", XS_BDB_db_open, file, "$$$$$$$;$");
        newXSproto("BDB::db_close", XS_BDB_db_close, file, "$;$$");
        newXSproto("BDB::db_compact", XS_BDB_db_compact, file, "$;$$$$$$$");
        newXSproto("BDB::db_sync", XS_BDB_db_sync, file, "$;$$");
        newXSproto("BDB::db_upgrade", XS_BDB_db_upgrade, file, "$$;$$");
        newXSproto("BDB::db_key_range", XS_BDB_db_key_range, file, "$$$$;$$");
        newXSproto("BDB::db_put", XS_BDB_db_put, file, "$$$$;$$");
#if XSubPPtmpAAAA
        newXSproto("BDB::db_exists", XS_BDB_db_exists, file, "$$$;$$");
#endif
        newXSproto("BDB::db_get", XS_BDB_db_get, file, "$$$$;$$");
        newXSproto("BDB::db_pget", XS_BDB_db_pget, file, "$$$$$;$$");
        newXSproto("BDB::db_del", XS_BDB_db_del, file, "$$$;$$");
        newXSproto("BDB::db_txn_commit", XS_BDB_db_txn_commit, file, "$;$$");
        newXSproto("BDB::db_txn_abort", XS_BDB_db_txn_abort, file, "$;$");
        newXSproto("BDB::db_txn_finish", XS_BDB_db_txn_finish, file, "$;$$");
        newXSproto("BDB::db_c_close", XS_BDB_db_c_close, file, "$;$");
        newXSproto("BDB::db_c_count", XS_BDB_db_c_count, file, "$$;$$");
        newXSproto("BDB::db_c_put", XS_BDB_db_c_put, file, "$$$;$$");
        newXSproto("BDB::db_c_get", XS_BDB_db_c_get, file, "$$$;$$");
        newXSproto("BDB::db_c_pget", XS_BDB_db_c_pget, file, "$$$$;$$");
        newXSproto("BDB::db_c_del", XS_BDB_db_c_del, file, "$;$$");
        newXSproto("BDB::db_sequence_open", XS_BDB_db_sequence_open, file, "$$$;$$");
        newXSproto("BDB::db_sequence_close", XS_BDB_db_sequence_close, file, "$;$$");
        newXSproto("BDB::db_sequence_get", XS_BDB_db_sequence_get, file, "$$$$;$$");
        newXSproto("BDB::db_sequence_remove", XS_BDB_db_sequence_remove, file, "$;$$$");
        newXSproto("BDB::Env::DESTROY", XS_BDB__Env_DESTROY, file, "$");
        newXSproto("BDB::Env::set_data_dir", XS_BDB__Env_set_data_dir, file, "$$");
        newXSproto("BDB::Env::set_tmp_dir", XS_BDB__Env_set_tmp_dir, file, "$$");
        newXSproto("BDB::Env::set_lg_dir", XS_BDB__Env_set_lg_dir, file, "$$");
        newXSproto("BDB::Env::set_shm_key", XS_BDB__Env_set_shm_key, file, "$$");
        newXSproto("BDB::Env::set_cachesize", XS_BDB__Env_set_cachesize, file, "$$$;$");
        newXSproto("BDB::Env::set_flags", XS_BDB__Env_set_flags, file, "$$;$");
#if XSubPPtmpAAAB
        newXSproto("BDB::Env::set_intermediate_dir_mode", XS_BDB__Env_set_intermediate_dir_mode, file, "$$");
        newXSproto("BDB::Env::log_set_config", XS_BDB__Env_log_set_config, file, "$$;$");
#endif
        newXSproto("BDB::Env::set_errfile", XS_BDB__Env_set_errfile, file, "$;$");
        newXSproto("BDB::Env::set_msgfile", XS_BDB__Env_set_msgfile, file, "$;$");
        newXSproto("BDB::Env::set_verbose", XS_BDB__Env_set_verbose, file, "$;$$");
        newXSproto("BDB::Env::set_encrypt", XS_BDB__Env_set_encrypt, file, "$$;$");
        newXSproto("BDB::Env::set_timeout", XS_BDB__Env_set_timeout, file, "$$;$");
        newXSproto("BDB::Env::set_mp_max_openfd", XS_BDB__Env_set_mp_max_openfd, file, "$$");
        newXSproto("BDB::Env::set_mp_max_write", XS_BDB__Env_set_mp_max_write, file, "$$$");
        newXSproto("BDB::Env::set_mp_mmapsize", XS_BDB__Env_set_mp_mmapsize, file, "$$");
        newXSproto("BDB::Env::set_lk_detect", XS_BDB__Env_set_lk_detect, file, "$;$");
        newXSproto("BDB::Env::set_lk_max_lockers", XS_BDB__Env_set_lk_max_lockers, file, "$$");
        newXSproto("BDB::Env::set_lk_max_locks", XS_BDB__Env_set_lk_max_locks, file, "$$");
        newXSproto("BDB::Env::set_lk_max_objects", XS_BDB__Env_set_lk_max_objects, file, "$$");
        newXSproto("BDB::Env::set_lg_bsize", XS_BDB__Env_set_lg_bsize, file, "$$");
        newXSproto("BDB::Env::set_lg_max", XS_BDB__Env_set_lg_max, file, "$$");
        newXSproto("BDB::Env::mutex_set_max", XS_BDB__Env_mutex_set_max, file, "$$");
        newXSproto("BDB::Env::mutex_set_increment", XS_BDB__Env_mutex_set_increment, file, "$$");
        newXSproto("BDB::Env::mutex_set_tas_spins", XS_BDB__Env_mutex_set_tas_spins, file, "$$");
        newXSproto("BDB::Env::mutex_set_align", XS_BDB__Env_mutex_set_align, file, "$$");
        newXSproto("BDB::Env::txn_begin", XS_BDB__Env_txn_begin, file, "$;$$");
#if XSubPPtmpAAAC
        newXSproto("BDB::Env::cdsgroup_begin", XS_BDB__Env_cdsgroup_begin, file, "$");
#endif
        newXSproto("BDB::Db::DESTROY", XS_BDB__Db_DESTROY, file, "$");
        newXSproto("BDB::Db::set_cachesize", XS_BDB__Db_set_cachesize, file, "$$$;$");
        newXSproto("BDB::Db::set_flags", XS_BDB__Db_set_flags, file, "$$");
        newXSproto("BDB::Db::set_encrypt", XS_BDB__Db_set_encrypt, file, "$$$");
        newXSproto("BDB::Db::set_lorder", XS_BDB__Db_set_lorder, file, "$$");
        newXSproto("BDB::Db::set_bt_minkey", XS_BDB__Db_set_bt_minkey, file, "$$");
        newXSproto("BDB::Db::set_re_delim", XS_BDB__Db_set_re_delim, file, "$$");
        newXSproto("BDB::Db::set_re_pad", XS_BDB__Db_set_re_pad, file, "$$");
        newXSproto("BDB::Db::set_re_source", XS_BDB__Db_set_re_source, file, "$$");
        newXSproto("BDB::Db::set_re_len", XS_BDB__Db_set_re_len, file, "$$");
        newXSproto("BDB::Db::set_h_ffactor", XS_BDB__Db_set_h_ffactor, file, "$$");
        newXSproto("BDB::Db::set_h_nelem", XS_BDB__Db_set_h_nelem, file, "$$");
        newXSproto("BDB::Db::set_q_extentsize", XS_BDB__Db_set_q_extentsize, file, "$$");
        newXSproto("BDB::Db::cursor", XS_BDB__Db_cursor, file, "$;$$");
        newXSproto("BDB::Db::sequence", XS_BDB__Db_sequence, file, "$;$");
        newXSproto("BDB::Txn::DESTROY", XS_BDB__Txn_DESTROY, file, "$");
        newXSproto("BDB::Txn::set_timeout", XS_BDB__Txn_set_timeout, file, "$$;$");
        newXSproto("BDB::Txn::failed", XS_BDB__Txn_failed, file, "$");
        newXSproto("BDB::Cursor::DESTROY", XS_BDB__Cursor_DESTROY, file, "$");
#if XSubPPtmpAAAD
        newXSproto("BDB::Cursor::set_priority", XS_BDB__Cursor_set_priority, file, "$$");
#endif
        newXSproto("BDB::Sequence::DESTROY", XS_BDB__Sequence_DESTROY, file, "$");
        newXSproto("BDB::Sequence::initial_value", XS_BDB__Sequence_initial_value, file, "$$");
        newXSproto("BDB::Sequence::set_cachesize", XS_BDB__Sequence_set_cachesize, file, "$$");
        newXSproto("BDB::Sequence::set_flags", XS_BDB__Sequence_set_flags, file, "$$");
        newXSproto("BDB::Sequence::set_range", XS_BDB__Sequence_set_range, file, "$$$");

    /* Initialisation Section */

#line 1098 "BDB.xs"
{
	HV *stash = gv_stashpv ("BDB", 1);

        static const struct {
          const char *name;
          IV iv;
        } *civ, const_iv[] = {
#define const_iv(name) { # name, (IV)DB_ ## name },
          const_iv (RPCCLIENT)
          const_iv (INIT_CDB)
          const_iv (INIT_LOCK)
          const_iv (INIT_LOG)
          const_iv (INIT_MPOOL)
          const_iv (INIT_REP)
          const_iv (INIT_TXN)
          const_iv (RECOVER)
          const_iv (INIT_TXN)
          const_iv (RECOVER_FATAL)
          const_iv (CREATE)
          const_iv (RDONLY)
          const_iv (USE_ENVIRON)
          const_iv (USE_ENVIRON_ROOT)
          const_iv (LOCKDOWN)
          const_iv (PRIVATE)
          const_iv (REGISTER)
          const_iv (SYSTEM_MEM)
          const_iv (AUTO_COMMIT)
          const_iv (CDB_ALLDB)
          const_iv (DIRECT_DB)
          const_iv (DSYNC_DB)
          const_iv (NOLOCKING)
          const_iv (NOMMAP)
          const_iv (NOPANIC)
          const_iv (OVERWRITE)
          const_iv (PANIC_ENVIRONMENT)
          const_iv (REGION_INIT)
          const_iv (TIME_NOTGRANTED)
          const_iv (TXN_NOSYNC)
          const_iv (TXN_NOT_DURABLE)
          const_iv (TXN_WRITE_NOSYNC)
          const_iv (WRITECURSOR)
          const_iv (YIELDCPU)
          const_iv (ENCRYPT_AES)
          const_iv (XA_CREATE)
          const_iv (BTREE)
          const_iv (HASH)
          const_iv (QUEUE)
          const_iv (RECNO)
          const_iv (UNKNOWN)
          const_iv (EXCL)
          const_iv (READ_COMMITTED)
          const_iv (READ_UNCOMMITTED)
          const_iv (TRUNCATE)
          const_iv (NOSYNC)
          const_iv (CHKSUM)
          const_iv (ENCRYPT)
          const_iv (DUP)
          const_iv (DUPSORT)
          const_iv (RECNUM)
          const_iv (RENUMBER)
          const_iv (REVSPLITOFF)
          const_iv (INORDER)
          const_iv (CONSUME)
          const_iv (CONSUME_WAIT)
          const_iv (GET_BOTH)
          const_iv (GET_BOTH_RANGE)
          //const_iv (SET_RECNO)
          //const_iv (MULTIPLE)
          const_iv (SNAPSHOT)
          const_iv (JOIN_ITEM)
          const_iv (JOIN_NOSORT)
          const_iv (RMW)

          const_iv (NOTFOUND)
          const_iv (KEYEMPTY)
          const_iv (LOCK_DEADLOCK)
          const_iv (LOCK_NOTGRANTED)
          const_iv (RUNRECOVERY)
          const_iv (OLD_VERSION)
          const_iv (REP_HANDLE_DEAD)
          const_iv (REP_LOCKOUT)
          const_iv (SECONDARY_BAD)

          const_iv (FREE_SPACE)
          const_iv (FREELIST_ONLY)

          const_iv (APPEND)
          const_iv (NODUPDATA)
          const_iv (NOOVERWRITE)

          const_iv (TXN_NOWAIT)
          const_iv (TXN_SYNC)

          const_iv (SET_LOCK_TIMEOUT)
          const_iv (SET_TXN_TIMEOUT)

          const_iv (FIRST)
          const_iv (NEXT)
          const_iv (NEXT_DUP)
          const_iv (NEXT_NODUP)
          const_iv (PREV)
          const_iv (PREV_NODUP)
          const_iv (SET)
          const_iv (SET_RANGE)
          const_iv (LAST)
          const_iv (BEFORE)
          const_iv (AFTER)
          const_iv (CURRENT)
          const_iv (KEYFIRST)
          const_iv (KEYLAST)
          const_iv (NODUPDATA)

          const_iv (FORCE)

          const_iv (LOCK_DEFAULT)
          const_iv (LOCK_EXPIRE)
          const_iv (LOCK_MAXLOCKS)
          const_iv (LOCK_MAXWRITE)
          const_iv (LOCK_MINLOCKS)
          const_iv (LOCK_MINWRITE)
          const_iv (LOCK_OLDEST)
          const_iv (LOCK_RANDOM)
          const_iv (LOCK_YOUNGEST)

          const_iv (SEQ_DEC)
          const_iv (SEQ_INC)
          const_iv (SEQ_WRAP)

          const_iv (BUFFER_SMALL)
          const_iv (DONOTINDEX)
          const_iv (KEYEMPTY	)
          const_iv (KEYEXIST	)
          const_iv (LOCK_DEADLOCK)
          const_iv (LOCK_NOTGRANTED)
          const_iv (LOG_BUFFER_FULL)
          const_iv (NOSERVER)
          const_iv (NOSERVER_HOME)
          const_iv (NOSERVER_ID)
          const_iv (NOTFOUND)
          const_iv (PAGE_NOTFOUND)
          const_iv (REP_DUPMASTER)
          const_iv (REP_HANDLE_DEAD)
          const_iv (REP_HOLDELECTION)
          const_iv (REP_IGNORE)
          const_iv (REP_ISPERM)
          const_iv (REP_JOIN_FAILURE)
          const_iv (REP_LOCKOUT)
          const_iv (REP_NEWMASTER)
          const_iv (REP_NEWSITE)
          const_iv (REP_NOTPERM)
          const_iv (REP_UNAVAIL)
          const_iv (RUNRECOVERY)
          const_iv (SECONDARY_BAD)
          const_iv (VERIFY_BAD)
          const_iv (VERSION_MISMATCH)

          const_iv (VERB_DEADLOCK)
          const_iv (VERB_RECOVERY)
          const_iv (VERB_REGISTER)
          const_iv (VERB_REPLICATION)
          const_iv (VERB_WAITSFOR)

          const_iv (VERSION_MAJOR)
          const_iv (VERSION_MINOR)
          const_iv (VERSION_PATCH)
#if DB_VERSION_MINOR >= 5
          const_iv (MULTIVERSION)
          const_iv (TXN_SNAPSHOT)
#endif
#if DB_VERSION_MINOR >= 6
          const_iv (PREV_DUP)
          const_iv (PRIORITY_UNCHANGED)
          const_iv (PRIORITY_VERY_LOW)
          const_iv (PRIORITY_LOW)
          const_iv (PRIORITY_DEFAULT)
          const_iv (PRIORITY_HIGH)
          const_iv (PRIORITY_VERY_HIGH)
#endif
#if DB_VERSION_MINOR >= 7
          const_iv (LOG_DIRECT)
          const_iv (LOG_DSYNC)
          const_iv (LOG_AUTO_REMOVE)
          const_iv (LOG_IN_MEMORY)
          const_iv (LOG_ZERO)
#else
          const_iv (DIRECT_LOG)
          const_iv (DSYNC_LOG)
          const_iv (LOG_AUTOREMOVE)
          const_iv (LOG_INMEMORY)
#endif
        };

        for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ-- > const_iv; )
          newCONSTSUB (stash, (char *)civ->name, newSViv (civ->iv));

        {
          /* we currently only allow version, minor-version and patchlevel to go up to 255 */
          char vstring[3] = { DB_VERSION_MAJOR, DB_VERSION_MINOR, DB_VERSION_PATCH };

          newCONSTSUB (stash, "VERSION_v", newSVpvn (vstring, 3));
        }

        newCONSTSUB (stash, "VERSION_STRING", newSVpv (DB_VERSION_STRING, 0));

        create_respipe ();

        X_THREAD_ATFORK (atfork_prepare, atfork_parent, atfork_child);
        patch_errno ();
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#line 5266 "BDB.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

